/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sslclientbase;

//Import Java
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Calendar;
import java.text.SimpleDateFormat;
//Import libreria di test Secure Edge S.r.l.
import net.rustichelli.security.HttpsGetPage;
//Import Commons Apache per BASE64
import org.apache.commons.codec.binary.Base64;

/**
 * * @author Secure Edge Srl
 */
public class Main {

   /**
    * @param args the command line arguments
    */
   public static void main(String[] args)
	{
		
            if (args.length == 6) {
                try
                    {
                            //Caricamento e Codifica file B64
                            File file = new File(args[1]);
                            if (file.exists())
                            {
                               //System.out.println("OK file exist!");
                            }
                            else
                            {
                               System.out.println("NO KO file NOT exist!");
                               System.exit(1); //calling the method is a must
                            }
                            byte[] bytes = loadFile(file);

                            //all chars in encoded are guaranteed to be 7-bit ASCII
                            byte[] encoded = Base64.encodeBase64(bytes);
                            //ATTENZIONE: non utilizzare la classe sun.misc.BASE64Encoder()
                            //Spesso il BASE64 non è corretto e l'intera classe è: DEPRECATED
                            //String encoded = new sun.misc.BASE64Encoder().encode(bytes);

                            //Codifica ASCII per stamparlo a video
                            String printMe = new String(encoded, "ASCII");
                            //String printMe = encoded;
                            //System.out.println(printMe);

                            HttpsGetPage retriever = new HttpsGetPage();
                            retriever.HttpsGetPage();

                            // HTTPS stuff
                            retriever.retrieveServerCert("Certs/pes-app-2009.0101FB.jks", "pippero", "mykey");
                            retriever.retrieveClientStuff("Certs/"+args[2], args[3], "JKS");

                            // PeS parameters: host, port (most likely 443), configuration name and data (Base64-encoded)
                            //retriever.setPeSParameters("https://pes.secure-edge.com/cgi-bin/", 443, "bellaria", printMe);
                            //retriever.setPeSParameters("192.168.41.15", 443, "enrico", printMe);
                            retriever.setPeSParameters(args[0], 443, args[4], printMe);
                            // PeS options: image width, height, DPI (any can be null)
                            retriever.addPeSIMGOptions(null, null, null); 

                            // option 1: retrieve PeS tag (or document) and write output to file
                            retriever.setOutputFileName("tag.out.jpg");
                            System.out.println("START: "+now("H:mm:ss:SSS"));
                            int num = Integer.parseInt(args[5]);
                            if (num == 0)
                            {                               
                                String rets = retriever.retrieveURL();
                                System.out.println("INFO: return string is : " + rets);
                            }
                            else
                            {
                               for (int i = 0; i < num; i++) {  // i indexes each element successively.
                                   String rets = retriever.retrieveURL();
                                   System.out.println("INFO: return string is : " + rets + " (" + i + ")");
                                    }
                            }
                            System.out.println("END: "+now("H:mm:ss:SSS"));
                            // (end of option 1)

                            // option 2: access the input stream then close it
                            // InputStream PeSStream = retriever.retrieveURLStream();
                            // (do something to use the stream...)
                            // PeSStream.close();
                    }
                    catch (Exception exc)
                    {
                        exc.printStackTrace();
                    }
            }
            else
            {
              System.out.println("Usage: sslclientbase <ip appliance> <file name input> <cert name file> <password> <configuration>\n");  
              //Example 192.168.41.15 file_input_test.rtf PeSDemoClient.01022A.jks pass1234 enrico
            }
	}
   
   public static String now(String dateFormat) {
    Calendar cal = Calendar.getInstance();
    SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
    return sdf.format(cal.getTime());

  }

   //Procedura copia file utilizzata da loadFile
   private static void copy(InputStream in, OutputStream out) throws IOException {
        byte[] barr = new byte[1024];
        while(true) {
                int r = in.read(barr);
                if(r <= 0) {
                        break;
                }
                out.write(barr, 0, r);
        }
    }

   //funzione caricamento file
   private static byte[] loadFile(File file) throws IOException {
        InputStream in = new FileInputStream(file);
        try {
                ByteArrayOutputStream buffer = new ByteArrayOutputStream();
                copy(in, buffer);
                return buffer.toByteArray();
        } finally {
                in.close();
        }
    }

}